/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/**
 * Title:        Checklist
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      University Bayreuth
 * @author Dieter Neubacher
 * @version 1.0
 */

package net.metadiversity.diversity.navigator.checklists;

// import javax.swing.JComponent;

public class FlagInput extends javax.swing.JPanel
{
/**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3618705184034009141L;
    
    private int fieldCount;
    private int selected;
    private javax.swing.JRadioButton [] radioButton;
    private javax.swing.ButtonGroup group;

    public FlagInput()
    {
        initComponents();
    }

    public void initComponents()
    {
        fieldCount = 14;
        radioButton = new javax.swing.JRadioButton[ fieldCount ];
        group       = new javax.swing.ButtonGroup();

        setLayout( new java.awt.GridLayout( 2, fieldCount / 2 ) );

        String [] labelText = { "", "unkown", "valid", "nom.nud.", "nom.illeg.", "nom.invalid", "",
                                "", "",       "",      "auct.",    "agg.",       "ined.",       ""
                              };

        add( new javax.swing.JLabel( "validity :") );

        for( int i = 1; i < fieldCount; i++ )
        {
            if( labelText[ i ].length() == 0 )
            {
                add( new javax.swing.JLabel() );
            }
            else
            {
                radioButton[ i ] = new javax.swing.JRadioButton( labelText[ i ] ) ;
                group.add( radioButton[ i ] );
                add( radioButton[ i ] );

	        radioButton[ i ].addKeyListener( new java.awt.event.KeyAdapter ()
	        {
	            public void keyReleased( java.awt.event.KeyEvent evt )
	            {
                        System.out.println( evt );
                        System.out.println( getParent() );
                        set();
	            }
	        }
	        );
                radioButton[ i ].addActionListener (new java.awt.event.ActionListener ()
                {
                    public void actionPerformed (java.awt.event.ActionEvent evt)
                    {
                        System.out.println( evt );
                        // System.out.println( group.getSelection() );
                        set();
                    }
                }
                );
            }
        }
    }
    private void set()
    {
                        for( int i = 0; i < fieldCount; i++ )
                        {
                            if( radioButton[ i ] != null && radioButton[ i ].isSelected() )
                            {
                                System.out.println( "gefunden: " + i );
                                selected = i;
                            }
                        }
    }
}
