/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/**
 * Title:        Checklist
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      University Bayreuth
 * @author Dieter Neubacher
 * @version 1.0
 */

package net.metadiversity.diversity.navigator.checklists.taxon;

public class TaxonSearchInput extends javax.swing.JPanel
{
/**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3762813809533662000L;
// private javax.swing.JPanel jPanelInputFieldsTaxon;

private int fieldCount;
private javax.swing.JLabel [] label;
private javax.swing.JLabel outputLine;
private javax.swing.JComboBox [] Field;

    public TaxonSearchInput()
    {
        outputLine = null;
        initComponents();
    }

    public TaxonSearchInput( javax.swing.JLabel output )
    {
        outputLine = output;
        initComponents();
    }

    public void initComponents()
    {

        fieldCount = 5;

//        String [] labelText = { "genus", "species", "subspecies", "variety", "form", "(author)", "author" };
        String [] labelText = { "genus", "species", "taxonomic rank", "(author)", "author" };

        label       = new javax.swing.JLabel[ fieldCount ];
        Field    = new javax.swing.JComboBox[ fieldCount ];

        setLayout( new java.awt.GridLayout( 2, fieldCount ) );

        // labels
        for( int i = 0; i < fieldCount; i++ )
        {
            label[ i ]      = new javax.swing.JLabel();
            label[ i ].setText( labelText[ i ] );
            add( label[ i ] );
        }
        // input fields
        for( int i = 0; i < fieldCount; i++ )
        {

                String [] choice = { "",
                                     "Artonia",
                                     "Arthopyrenia",
                                     "Arthohelium",
                                     "Aspicilia",
                                     "Asteroporum",
                                     "Asterotrema",
                                     "Aulaxina",
                                     "Australiaena"
                                   };

            Field[ i ]  = new javax.swing.JComboBox();

            Field[ i ].setEditable( true );

            for( int n = 0; n < 9; n++ )
            {
                Field[ i ].addItem( choice[ n ] );
            }
            Field[ i ].setMaximumRowCount( 5 );
            Field[ i ].setSelectedIndex( 0 );

            add( Field[ i ] );

            Field[ i ].addKeyListener( new java.awt.event.KeyAdapter ()
            {
                public void keyReleased( java.awt.event.KeyEvent evt )
                {
		    showOutputLine();
                }
            }
	    );

            Field[ i ].addActionListener (new java.awt.event.ActionListener ()
	    {
	        public void actionPerformed (java.awt.event.ActionEvent evt)
	        {
		    showOutputLine();
	        }
            }
	    );
        }
/*
	jLabelOutputLine         = new javax.swing.JLabel();
        jLabelOutputLine.setForeground( java.awt.Color.red );
        jLabelOutputLine.setFont( new java.awt.Font ( "Dialog", 1, 12 ) );
        jLabelOutputLine.setHorizontalAlignment( javax.swing.SwingConstants.CENTER );
*/
    }
    /*
    public void setGenus( String s )            { Field[ 0 ].setText( s ); }
    public void setSpecies( String s )          { Field[ 1 ].setText( s ); }
    public void setSubSpecies( String s )       { Field[ 2 ].setText( s ); }
    public void setVariety( String s )          { Field[ 3 ].setText( s ); }
    public void setForm( String s )             { Field[ 4 ].setText( s ); }
    public void setFirstDiscription( String s ) { Field[ 5 ].setText( s ); }
    public void setAuthor( String s )           { Field[ 6 ].setText( s ); }

    public String getGenus()            { return Field[ 0 ].getText().trim(); }
    public String getSpecies()          { return Field[ 1 ].getText().trim(); }
    public String getSubSpecies()       { return Field[ 2 ].getText().trim(); }
    public String getVariety()          { return Field[ 3 ].getText().trim(); }
    public String getForm()             { return Field[ 4 ].getText().trim(); }
    public String getFirstDiscription() { return Field[ 5 ].getText().trim(); }
    public String getAuthor()           { return Field[ 6 ].getText().trim(); }
    */



    private void showOutputLine()
    {
	java.lang.StringBuffer out = new java.lang.StringBuffer();

	if( Field[ 0 ].getSelectedItem().toString().trim().length() != 0 )
	    out.append( Field[ 0 ].getSelectedItem().toString() + " " );

	if( Field[ 1 ].getSelectedItem().toString().trim().length() != 0 )
	    out.append( Field[ 1 ].getSelectedItem().toString() + " " );

	if( Field[ 2 ].getSelectedItem().toString().trim().length() != 0 )
	    out.append( "sub. " + Field[ 2 ].getSelectedItem().toString() + " " );

	if( Field[ 3 ].getSelectedItem().toString().trim().length() != 0 )
	    out.append( "var. " + Field[ 3 ].getSelectedItem().toString() + " " );

	if( Field[ 4 ].getSelectedItem().toString().trim().length() != 0 )
	    out.append( "f. " + Field[ 4 ].getSelectedItem().toString() + " " );

	if( Field[ 5 ].getSelectedItem().toString().trim().length() != 0 )
	    out.append( "(" + Field[ 5 ].getSelectedItem().toString() + ") "  );

	if( Field[ 6 ].getSelectedItem().toString().trim().length() != 0 )
	    out.append( Field[ 6 ].getSelectedItem().toString() + " " );

	outputLine.setText( out.toString() );
	outputLine.setVisible( true );
    }

}
