/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * DBTreeCellRenderer.java
 *
 * Created on 22. Juli 2003, 18:37
 */

package net.metadiversity.diversity.navigator.db;

import org.apache.log4j.Logger;

import java.awt.Component;
//import javax.swing.*;
//import javax.swing.tree.*;

import net.metadiversity.diversity.navigator.*;
//import net.metadiversity.diversity.navigator.connection.*;

/**
 *
 * @author  Dieter Neubacher
 */
public class DBTreeCellRenderer extends javax.swing.tree.DefaultTreeCellRenderer
{
    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3258410651234743857L;
    static Logger logger = Logger.getLogger( DBTreeCellRenderer.class.getName() );
    
    /** Creates a new instance of DBTreeCellRenderer */
    public DBTreeCellRenderer()
    {
    }
    public Component getTreeCellRendererComponent( javax.swing.JTree tree, Object value, boolean selected, boolean expanded, boolean leaf, int row, boolean hasFocus)
    {
        super.getTreeCellRendererComponent( tree, value, selected, expanded, leaf, row, hasFocus );
        // get user element
        DBNode node = ( DBNode ) value;        
        switch( node.getNodeType() )
        {
            case DBNode.NODE_TYPE_CAPTION_CONNECTIONS :                
                super.setIcon( DiversityNavigatorProperties.getDbTreeRootIcon() );
                break;
            case DBNode.NODE_TYPE_DATABASE :
                super.setIcon( DiversityNavigatorProperties.getDbTreeDatabaseIcon() );
                break;
            case DBNode.NODE_TYPE_TABLE :
                super.setIcon( DiversityNavigatorProperties.getDbTreeTableIcon() );
                break;
            case DBNode.NODE_TYPE_FIELD :
                super.setIcon( DiversityNavigatorProperties.getDbTreeFieldIcon() );
                break;
        }
        return this;
   }
                                            
//   private dbIcon = null;
    
}
