/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * CollectionTabIndentification.java
 *
 * Created on 15. September 2004, 11:39
 */

package net.metadiversity.diversity.navigator.gui;

import com.jgoodies.forms.layout.*;
import com.jgoodies.forms.layout.ColumnSpec;

import net.metadiversity.diversity.navigator.db.ub.DnDataRecordSelector;

/**
 *
 * @author  didi
 */
public class CollectionTabGeographicData extends com.jgoodies.forms.builder.PanelBuilder
{
    // form format strings
    String columnFormatString   = "";
    String rowFormatString      = "";
    
    com.jgoodies.forms.builder.PanelBuilder     builder;
    // default format values
    static final String DEFAULT_COLUMNE_FORMAT = "fill:d:grow";
    static final String PAD_COLUMNE_FORMAT     = "fill:3dlu:nogrow";
    static final String DEFAULT_ROW_FORMAT     = "fill:d:nogrow";
    static final String PAD_ROW_FORMAT         = "fill:3dlu:nogrow";    
    // Form parameter
    int xMaxFormPos;
    int yMaxFormPos;
    // debug
    boolean DEBUG_ADD_COMPONENT = false;
    boolean DEBUG_LINE_AND_ROW_NUMBERS = false;
    //
    CellConstraints cc;

    public DnDataRecordSelector        localityRecords;
    
    public void showLineNumbers( boolean b )
    {
        DEBUG_LINE_AND_ROW_NUMBERS = b;
    }
    
    public CollectionTabGeographicData()
    {
        super( new com.jgoodies.forms.layout.FormLayout( "", "" ) );
        showLineNumbers( false );
        cc = new CellConstraints();
        xMaxFormPos = 9;
        yMaxFormPos = 10;
        
        ColumnSpec colPad = new com.jgoodies.forms.layout.ColumnSpec( PAD_COLUMNE_FORMAT );              
        ColumnSpec colDef = new com.jgoodies.forms.layout.ColumnSpec( DEFAULT_COLUMNE_FORMAT );              
        
        RowSpec rowPad = new com.jgoodies.forms.layout.RowSpec( PAD_ROW_FORMAT );              
        RowSpec rowDef = new com.jgoodies.forms.layout.RowSpec( DEFAULT_ROW_FORMAT );              
        
        if( DEBUG_LINE_AND_ROW_NUMBERS )
        {
            appendColumn( colDef );
            appendRow( rowDef );
        }
        else
        {
            appendColumn( colPad );
            appendRow( rowPad );                
        }
        
        for( int col = 1; col <= xMaxFormPos; col++ )
        {
            appendColumn( colDef );
            if( DEBUG_LINE_AND_ROW_NUMBERS && col == xMaxFormPos )
            {
                appendColumn( colDef );
            }
            else
            {
                appendColumn( colPad );
            }
        }
        for( int row = 1; row <= yMaxFormPos; row++ )
        {   
            appendRow( rowDef );
            if( DEBUG_LINE_AND_ROW_NUMBERS && row == yMaxFormPos )
            {
                appendRow( rowDef );
            }
            else
            {
                appendRow( rowPad );                   
            }
            if( DEBUG_LINE_AND_ROW_NUMBERS )
            {
                // Set line numbers 
                javax.swing.JLabel l1 = new javax.swing.JLabel( String.valueOf( row ) );
                add( l1, cc.xy( 1 , row * 2 ) );
                javax.swing.JLabel l2 = new javax.swing.JLabel( String.valueOf( row ) );
                add( l2, cc.xy( xMaxFormPos * 2 + 1, row * 2 ) );
            }
            else
            {
                javax.swing.JLabel l1 = new javax.swing.JLabel( " " );
                add( l1, cc.xy( 1 , row * 2 ) );                
            }
        }
        
        for( int col = 1; col <= xMaxFormPos; col++ )
        {
            if( DEBUG_LINE_AND_ROW_NUMBERS )
            {
                // set column numbers
                javax.swing.JLabel l1 = new javax.swing.JLabel( String.valueOf( col ) );
                add( l1, cc.xy( col * 2, 1 ) );
                javax.swing.JLabel l2 = new javax.swing.JLabel( String.valueOf( col ) );
                add( l2, cc.xy( col * 2, yMaxFormPos * 2 + 1 ) );
            }
        }
        if( ! DEBUG_LINE_AND_ROW_NUMBERS )
        {
        }        
        
        //----------------------------------------------------------------------
        // Add Record selector 
        //----------------------------------------------------------------------
        localityRecords  = new DnDataRecordSelector();
        
        java.awt.GridBagConstraints gridBagConstraints;
        
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.gridwidth = 2;
        add( localityRecords, gridBagConstraints );
                
        initComponents();                
        // Scrollbar not avilible for "text/plane"
        // jTextPaneLocalityHabitat.setContentType( "text/html" );
        // jTextPaneLocalityProblems.setContentType( "text/html" );
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private void debug( int x, int y, int l, int h )
    {
        System.out.println( "x: " + x +  " \ty: " + y + " \tl:" + l );
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private void setLayout( java.awt.LayoutManager lm )
    {
        
    }
    void add( javax.swing.JComponent c, java.awt.GridBagConstraints gbc )    
    {
        cc = new CellConstraints();
        System.out.println( c );
        // Don't show Lable outside the form
        if( gbc.gridx > xMaxFormPos || gbc.gridy > yMaxFormPos )
        {
            return;
        }
        cc.xywh( ( gbc.gridx + 1 ) * 2, ( gbc.gridy + 1 ) * 2, ( gbc.gridwidth * 2 ) -1, ( gbc.gridheight * 2 ) -1 );
        System.out.println( cc );        
        add( c, cc );
        
    }
    /** This method is called from within the constructor to     
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents()//GEN-BEGIN:initComponents
    {
        java.awt.GridBagConstraints gridBagConstraints;

        jLabelProblems = new javax.swing.JLabel();
        jLabelLocality = new javax.swing.JLabel();
        jLabelHabitat = new javax.swing.JLabel();
        jScrollPaneLocalityHabitat = new javax.swing.JScrollPane();
        jTextPaneLocalityHabitat = new javax.swing.JTextPane();
        jScrollPaneProblems = new javax.swing.JScrollPane();
        jTextPaneLocalityProblems = new javax.swing.JTextPane();
        jLabelLocalisationSystem = new javax.swing.JLabel();
        jComboBoxLocationSystem = new javax.swing.JComboBox();
        jLabelLongitude = new javax.swing.JLabel();
        jTextFieldLongitude = new javax.swing.JTextField();
        jLabelLatitude = new javax.swing.JLabel();
        jTextFieldLatitude = new javax.swing.JTextField();
        jLabelResponsible = new javax.swing.JLabel();
        jLabelDate = new javax.swing.JLabel();
        jTextFieldDate = new javax.swing.JTextField();
        jComboBoxResponsible = new javax.swing.JComboBox();

        setLayout(new java.awt.GridBagLayout());

        jLabelProblems.setText("Problems");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        add(jLabelProblems, gridBagConstraints);

        jLabelLocality.setText("Locality /");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        add(jLabelLocality, gridBagConstraints);

        jLabelHabitat.setText("habitat");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        add(jLabelHabitat, gridBagConstraints);

        jTextPaneLocalityHabitat.setText("Locality / habitat line 1\nLocality / habitat line 2\nLocality / habitat line 3\nLocality / habitat line 4");
        jScrollPaneLocalityHabitat.setViewportView(jTextPaneLocalityHabitat);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 8;
        gridBagConstraints.gridheight = 3;
        add(jScrollPaneLocalityHabitat, gridBagConstraints);

        jTextPaneLocalityProblems.setText("Problem line 1\nProblem line 2\nProblem line 3\nProblem line 4");
        jScrollPaneProblems.setViewportView(jTextPaneLocalityProblems);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 8;
        gridBagConstraints.gridheight = 3;
        add(jScrollPaneProblems, gridBagConstraints);

        jLabelLocalisationSystem.setText("Localisation system");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        add(jLabelLocalisationSystem, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 6;
        add(jComboBoxLocationSystem, gridBagConstraints);

        jLabelLongitude.setText("Longitude (EW)");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        add(jLabelLongitude, gridBagConstraints);

        jTextFieldLongitude.setText("Longitude");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 7;
        add(jTextFieldLongitude, gridBagConstraints);

        jLabelLatitude.setText("Latitude (NS)");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 8;
        add(jLabelLatitude, gridBagConstraints);

        jTextFieldLatitude.setText("Latitude");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 8;
        add(jTextFieldLatitude, gridBagConstraints);

        jLabelResponsible.setText("Responsible");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 6;
        gridBagConstraints.gridy = 6;
        add(jLabelResponsible, gridBagConstraints);

        jLabelDate.setText("Date");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 6;
        gridBagConstraints.gridy = 7;
        add(jLabelDate, gridBagConstraints);

        jTextFieldDate.setText("Date");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 7;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.gridwidth = 2;
        add(jTextFieldDate, gridBagConstraints);

        jComboBoxResponsible.setEditable(true);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 7;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 2;
        add(jComboBoxResponsible, gridBagConstraints);

    }//GEN-END:initComponents
    
    public static void main( String [] args  )
    {
        CollectionTabGeographicData p = new CollectionTabGeographicData();
        javax.swing.JFrame f = new javax.swing.JFrame();        
        f.getContentPane().add( p.getPanel() );
        f.setVisible( true );
        f.setDefaultCloseOperation( javax.swing.JFrame.DISPOSE_ON_CLOSE );
    }
    
    /**
     * Getter for property jTextFieldLatitude.
     * @return Value of property jTextFieldLatitude.
     */
    public javax.swing.JTextField getJTextFieldLatitude()
    {
        return jTextFieldLatitude;
    }    
    
    /**
     * Setter for property jTextFieldLatitude.
     * @param jTextFieldLatitude New value of property jTextFieldLatitude.
     */
    public void setJTextFieldLatitude(javax.swing.JTextField jTextFieldLatitude)
    {
        this.jTextFieldLatitude = jTextFieldLatitude;
    }
    
    /**
     * Getter for property jTextFieldDate.
     * @return Value of property jTextFieldDate.
     */
    public javax.swing.JTextField getJTextFieldDate()
    {
        return jTextFieldDate;
    }
    
    /**
     * Setter for property jTextFieldDate.
     * @param jTextFieldDate New value of property jTextFieldDate.
     */
    public void setJTextFieldDate(javax.swing.JTextField jTextFieldDate)
    {
        this.jTextFieldDate = jTextFieldDate;
    }
    
    /**
     * Getter for property jTextFieldLongitude.
     * @return Value of property jTextFieldLongitude.
     */
    public javax.swing.JTextField getJTextFieldLongitude()
    {
        return jTextFieldLongitude;
    }
    
    /**
     * Setter for property jTextFieldLongitude.
     * @param jTextFieldLongitude New value of property jTextFieldLongitude.
     */
    public void setJTextFieldLongitude(javax.swing.JTextField jTextFieldLongitude)
    {
        this.jTextFieldLongitude = jTextFieldLongitude;
    }
    
    /**
     * Getter for property jTextPaneLocalityHabitat.
     * @return Value of property jTextPaneLocalityHabitat.
     */
    public javax.swing.JTextPane getJTextPaneLocalityHabitat()
    {
        return jTextPaneLocalityHabitat;
    }
    
    /**
     * Setter for property jTextPaneLocalityHabitat.
     * @param jTextPaneLocalityHabitat New value of property jTextPaneLocalityHabitat.
     */
    public void setJTextPaneLocalityHabitat(javax.swing.JTextPane jTextPaneLocalityHabitat)
    {
        this.jTextPaneLocalityHabitat = jTextPaneLocalityHabitat;
    }
    
    /**
     * Getter for property jTextPaneLocalityProblems.
     * @return Value of property jTextPaneLocalityProblems.
     */
    public javax.swing.JTextPane getJTextPaneLocalityProblems()
    {
        return jTextPaneLocalityProblems;
    }
    
    /**
     * Setter for property jTextPaneLocalityProblems.
     * @param jTextPaneLocalityProblems New value of property jTextPaneLocalityProblems.
     */
    public void setJTextPaneLocalityProblems(javax.swing.JTextPane jTextPaneLocalityProblems)
    {
        this.jTextPaneLocalityProblems = jTextPaneLocalityProblems;
    }
    
    /**
     * Getter for property jComboBoxLocationSystem.
     * @return Value of property jComboBoxLocationSystem.
     */
    public javax.swing.JComboBox getJComboBoxLocationSystem()
    {
        return jComboBoxLocationSystem;
    }
    
    /**
     * Setter for property jComboBoxLocationSystem.
     * @param jComboBoxLocationSystem New value of property jComboBoxLocationSystem.
     */
    public void setJComboBoxLocationSystem(javax.swing.JComboBox jComboBoxLocationSystem)
    {
        this.jComboBoxLocationSystem = jComboBoxLocationSystem;
    }
    
    /**
     * Getter for property jComboBoxResponsible.
     * @return Value of property jComboBoxResponsible.
     */
    public javax.swing.JComboBox getJComboBoxResponsible()
    {
        return jComboBoxResponsible;
    }
    
    /**
     * Setter for property jComboBoxResponsible.
     * @param jComboBoxResponsible New value of property jComboBoxResponsible.
     */
    public void setJComboBoxResponsible(javax.swing.JComboBox jComboBoxResponsible)
    {
        this.jComboBoxResponsible = jComboBoxResponsible;
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JComboBox jComboBoxLocationSystem;
    private javax.swing.JComboBox jComboBoxResponsible;
    private javax.swing.JLabel jLabelDate;
    private javax.swing.JLabel jLabelHabitat;
    private javax.swing.JLabel jLabelLatitude;
    private javax.swing.JLabel jLabelLocalisationSystem;
    private javax.swing.JLabel jLabelLocality;
    private javax.swing.JLabel jLabelLongitude;
    private javax.swing.JLabel jLabelProblems;
    private javax.swing.JLabel jLabelResponsible;
    private javax.swing.JScrollPane jScrollPaneLocalityHabitat;
    private javax.swing.JScrollPane jScrollPaneProblems;
    private javax.swing.JTextField jTextFieldDate;
    private javax.swing.JTextField jTextFieldLatitude;
    private javax.swing.JTextField jTextFieldLongitude;
    private javax.swing.JTextPane jTextPaneLocalityHabitat;
    private javax.swing.JTextPane jTextPaneLocalityProblems;
    // End of variables declaration//GEN-END:variables
    
}
