/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * ListMultiSelection.java
 *
 * Created on 24. Mai 2004, 14:49
 */

package net.metadiversity.diversity.navigator.gui;


import net.metadiversity.diversity.navigator.gui.DnOptionPane;

/**
 *
 * @author  didi
 */
public class ListMultiSelection extends javax.swing.JPanel
{
    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3257572810455922482L;
    javax.swing.DefaultListModel model;    
    java.util.Vector    selectedItems;
    java.util.Vector    unselectedItems;
    javax.swing.JFrame  frame;
    
    /** Creates new form ListMultiSelection */
    public ListMultiSelection( javax.swing.JFrame f, java.util.Vector selectedItems, java.util.Vector unselectedItems )
    {
        frame = f;
        this.selectedItems   = selectedItems;
        this.unselectedItems = unselectedItems;
        model = new javax.swing.DefaultListModel();
        
        if( selectedItems == null )
        {    
            selectedItems = new java.util.Vector();        
            selectedItems.add( "Data 1" );
            selectedItems.add( "Data 2" );
            selectedItems.add( "Data 3" );
            selectedItems.add( "Data 4" );
        }        
        if( unselectedItems == null )
        {    
            unselectedItems = new java.util.Vector();        
            unselectedItems.add( "Data 5" );
            unselectedItems.add( "Data 6" );
            unselectedItems.add( "Data 7" );
            unselectedItems.add( "Data 8" );
        }
        // init items
        java.util.ListIterator iter = selectedItems.listIterator();
        while( iter.hasNext() )
        {
            model.addElement( iter.next() );
        }        
        initComponents();
        setSize( 300, 120 );
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents()//GEN-BEGIN:initComponents
    {
        panel = new javax.swing.JPanel();
        addButton = new javax.swing.JButton();
        deleteButton = new javax.swing.JButton();
        helpButton = new javax.swing.JButton();
        scrollPane = new javax.swing.JScrollPane();
        list = new javax.swing.JList();

        setLayout(new java.awt.BorderLayout());

        panel.setLayout(new java.awt.GridLayout(0, 1));

        addButton.setMnemonic('A');
        addButton.setText("Add");
        addButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                addButtonActionPerformed(evt);
            }
        });

        panel.add(addButton);

        deleteButton.setMnemonic('D');
        deleteButton.setText("Delete");
        deleteButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                deleteButtonActionPerformed(evt);
            }
        });

        panel.add(deleteButton);

        helpButton.setMnemonic('H');
        helpButton.setText("Help");
        helpButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                helpButtonActionPerformed(evt);
            }
        });

        panel.add(helpButton);

        add(panel, java.awt.BorderLayout.EAST);

        list.setModel(model);
        scrollPane.setViewportView(list);

        add(scrollPane, java.awt.BorderLayout.CENTER);

    }//GEN-END:initComponents

    private void helpButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_helpButtonActionPerformed
    {//GEN-HEADEREND:event_helpButtonActionPerformed
        // Add your handling code here:
    }//GEN-LAST:event_helpButtonActionPerformed

    private void deleteButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_deleteButtonActionPerformed
    {//GEN-HEADEREND:event_deleteButtonActionPerformed
        Object [] sel = list.getSelectedValues();
        if( sel != null )
        {
            for( int i = 0; i < sel.length; i++ )
            {
                if( DnOptionPane.showConfirmDialog( frame, "Do you really want to delete this entry: " + sel[ i ], "Confirmation", DnOptionPane.YES_NO_OPTION ) == DnOptionPane.OK_OPTION )
                {
                    selectedItems.remove( sel[ i ] );
                    model.removeElement(  sel[ i ] );
                    unselectedItems.add(  sel[ i ] );
                }
            }
        }
    }//GEN-LAST:event_deleteButtonActionPerformed

    private void addButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_addButtonActionPerformed
    {//GEN-HEADEREND:event_addButtonActionPerformed
        // Add your handling code here:
        PopupSelectionList psl = new PopupSelectionList( frame, true, unselectedItems );
        System.out.println( frame.getLocation() );
        psl.setLocation( frame.getLocation() );
        psl.setVisible( true );
        
        System.out.println( "Add:" );        
        java.util.Vector v = psl.getSelectedValues();
        if( v != null )
        {
            for( int i = 0; i < v.size(); i++ )
            {
                 selectedItems.add( v.get( i ) );
                 model.addElement( v.get( i ) );
                 unselectedItems.remove( v.get( i ) );
            }                 
        }
    }//GEN-LAST:event_addButtonActionPerformed
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[])
    {
        java.util.Vector    selectedItems;
        java.util.Vector    unselectedItems;
        
        selectedItems = new java.util.Vector();        
        selectedItems.add( "Diversity Workbench 1" );
        selectedItems.add( "Diversity Workbench 2" );
        selectedItems.add( "Diversity Workbench 3" );
        selectedItems.add( "Diversity Workbench 4" );
        
        unselectedItems = new java.util.Vector();        
        unselectedItems.add( "Data 1" );
        unselectedItems.add( "Data 2" );
        unselectedItems.add( "Data 3" );
        unselectedItems.add( "Data 4" );
        
        javax.swing.JFrame f = new javax.swing.JFrame();
        ListMultiSelection lms = new ListMultiSelection( f, selectedItems, unselectedItems );
        lms.setVisible( true );
        f.getContentPane().add( lms );
        f.setSize( 400, 200 );
        f.setVisible( true );
        /*
        Object [] selectedObjects = lms.getSelectedValues();        
        for( int i = 0; i < selectedObjects.length; i++ )
        {
            System.out.println( (String) selectedObjects[ i ] );
        } 
         */
    }    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton addButton;
    private javax.swing.JButton deleteButton;
    private javax.swing.JButton helpButton;
    private javax.swing.JList list;
    private javax.swing.JPanel panel;
    private javax.swing.JScrollPane scrollPane;
    // End of variables declaration//GEN-END:variables
    
}
