/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package net.metadiversity.diversity.navigator.gui;

import org.apache.log4j.Logger;

import java.sql.*;
import javax.swing.table.*;

/**
 * Store ResultSet and MetaData for QueryresultSetTable
*/
abstract class QueryResultSetTableModel extends AbstractTableModel
{
    static Logger logger = Logger.getLogger( QueryResultSetTableModel.class.getName() );
    
    private boolean             debugFlag = true;
    
    private java.sql.ResultSet rs;
    private java.sql.ResultSetMetaData rsmd;
    /**
      Construct an new TableModel
      @param aResultSet ResultSet
    */
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public QueryResultSetTableModel( java.sql.ResultSet use_rs )
    {
        rs = use_rs;
        try
        {
            rsmd = rs.getMetaData();
        }
        catch( SQLException ex )
        {
            logger.error( ex.getMessage(), ex.fillInStackTrace() );
        }
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public String getColumnName( int c )
    {
        try
        {
            return rsmd.getColumnName( c + 1 );
        }
        catch( SQLException ex )
        {
            logger.error( ex.getMessage(), ex.fillInStackTrace() );
            return "";
        }
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public int getColumnCount()
    {
        try
        {
            return rsmd.getColumnCount();
        }
        catch( SQLException ex )
        {
            logger.error( ex.getMessage(), ex.fillInStackTrace() );
            return 0;
        }
    }
    //----------------------------------------------------------------------
    //----------------------------------------------------------------------
   /**
      Get ResultSet for this Model
      @return ResultSet
   */
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    protected java.sql.ResultSet getResultSet()
    {
        return rs;
    }
}
