/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * CharacterStateModel.java
 *
 * Created on 13. Februar 2004, 19:35
 */

package net.metadiversity.diversity.navigator.gui.delta_editor;

import net.metadiversity.diversity.navigator.db.delta_editor.CharacterStateElement;

import org.apache.log4j.Logger;
/**
 *
 * @author  didi
 */
// public class CharacterStateModel extends javax.swing.table.DefaultTableModel
public class CharacterStateModel implements javax.swing.table.TableModel
{
    static Logger logger = Logger.getLogger( CharacterStateModel.class.getName() );
    
    
    javax.swing.event.EventListenerList listenerList;
    DeltaEditorChangeEvent deltaEditorChangeEvent;
    
    java.util.Vector states = null;
    java.lang.String characterName = null;            
    //------------------------------------------------------------------
    public CharacterStateModel()
    {
        states = new java.util.Vector();
        this.characterName = "Character Name";   
        
        listenerList = new javax.swing.event.EventListenerList();
    }
    //------------------------------------------------------------------
    public CharacterStateModel( java.lang.String characterName )
    {
        states = new java.util.Vector();
        this.characterName = characterName;                                

        listenerList = new javax.swing.event.EventListenerList();        
    }
    //------------------------------------------------------------------
    public void addCharacterStateElement( CharacterStateElement cse )
    {
        states.add( cse );
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public int getColumnCount() 
    {
        return 3;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public int getRowCount() 
    {
        if( states == null )
            return 0;
        return states.size();
    }    
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public Object getValueAt( int row, int col ) 
    {
        switch( col ) 
        {
            case 0 :    return (( CharacterStateElement ) states.get( row ) ).isSelected();
            case 1 :    return (( CharacterStateElement ) states.get( row ) ).getTypeString();
            case 2 :    return (( CharacterStateElement ) states.get( row ) ).getName();
            default:    return null;
        }
    }
    //------------------------------------------------------------------
    public Class getColumnClass( int columnIndex ) 
    {
        switch( columnIndex )
        {
            case 0:     return Boolean.class;
            case 1:     return String.class;
            case 2:     return String.class;
            default:    return null;
        }
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public String getColumnName( int col ) 
    {
        switch( col )
        {
            case 0:
                return "Sel.";
            case 1:
                return "CS";
            case 2:    
                return characterName;
            default:
                return "none";
        }
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public boolean isCellEditable( int row, int col ) 
    {
        if( col == 0 )
            return true;
        else
            return false;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public void setValueAt( Object obj, int row, int col ) 
    {
        if( col == 0) // only checkbox
        {
            // System.out.println( "ROW : " + row  + " COL: " + col + " OBJ: " + obj ); 
            if( ((Boolean) obj).booleanValue() )
            {
                // add this characterState
                deltaEditorChangeEvent = new DeltaEditorChangeEvent( this, DeltaEditorChangeEvent.ADD_CHARACTER_STATE, row, col );            
            }
            else
            {
                // remove this characterState
                deltaEditorChangeEvent = new DeltaEditorChangeEvent( this, DeltaEditorChangeEvent.REMOVE_CHARACTER_STATE, row, col );            
            }
            (( CharacterStateElement ) states.get( row ) ).setSelected( ((Boolean) obj).booleanValue() );
            
            fireChangeListener();
        }
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public void addTableModelListener( javax.swing.event.TableModelListener listener ) 
    {
        listenerList.add( javax.swing.event.TableModelListener.class , listener );
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public void removeTableModelListener( javax.swing.event.TableModelListener listener ) 
    {
        listenerList.remove( javax.swing.event.TableModelListener.class, listener );
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public void addDeltaEditorChangeListener( DeltaEditorChangeListener listener ) 
    {
        listenerList.add( DeltaEditorChangeListener.class , listener );
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public void removeDeltaEditorChangeListener( DeltaEditorChangeListener listener ) 
    {
        listenerList.remove( DeltaEditorChangeListener.class , listener );
    }
    //--------------------------------------------------------------------------
    // Notify all listeners that have registered interest for
    // notification on this event type.  The event instance 
    // is lazily created using the parameters passed into 
    // the fire method.
    //--------------------------------------------------------------------------
    protected void fireChangeListener() 
    {
        // Guaranteed to return a non-null array
        Object[] listeners = listenerList.getListenerList();
        // Process the listeners last to first, notifying
        // those that are interested in this event
        for( int i = listeners.length-2; i >= 0; i -= 2 ) 
        {
            if( listeners[i] == DeltaEditorChangeListener.class ) 
            {
                // Lazily create the event:
                if( deltaEditorChangeEvent == null )
                {
                    deltaEditorChangeEvent = new DeltaEditorChangeEvent( this );
                }
                (( DeltaEditorChangeListener ) listeners[ i + 1 ] ).stateChanged( deltaEditorChangeEvent );
            }
        }
    }    
    //--------------------------------------------------------------------------
    // Set selection for this CharacterState
    // obj is type off Boolean
    //--------------------------------------------------------------------------
    public void setCaracterStateSeletion( boolean b, java.lang.String characterState ) 
    {
        java.util.Iterator iter = states.listIterator();
        while( iter.hasNext() )
        {
            CharacterStateElement cse = ( CharacterStateElement ) iter.next();
            
            if( cse.getTypeString().compareTo( characterState ) == 0 )
            {
                cse.setSelected( b );
            }
        }
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------                
}
