/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package net.metadiversity.diversity.navigator.hibernate.ubt.collection;

import java.io.Serializable;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;


/** @author Hibernate CodeGenerator */
public class CollectionStoragePK implements Serializable {

    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3257854259629472054L;

    /** identifier field */
    private Integer collectionSpecimenId;

    /** identifier field */
    private Integer collectionId;

    /** identifier field */
    private String materialCategory;

    /** full constructor */
    public CollectionStoragePK(Integer collectionSpecimenId, Integer collectionId, String materialCategory) {
        this.collectionSpecimenId = collectionSpecimenId;
        this.collectionId = collectionId;
        this.materialCategory = materialCategory;
    }

    /** default constructor */
    public CollectionStoragePK() {
    }

    public Integer getCollectionSpecimenId() {
        return this.collectionSpecimenId;
    }

    public void setCollectionSpecimenId(Integer collectionSpecimenId) {
        this.collectionSpecimenId = collectionSpecimenId;
    }

    public Integer getCollectionId() {
        return this.collectionId;
    }

    public void setCollectionId(Integer collectionId) {
        this.collectionId = collectionId;
    }

    public String getMaterialCategory() {
        return this.materialCategory;
    }

    public void setMaterialCategory(String materialCategory) {
        this.materialCategory = materialCategory;
    }

    public String toString() {
        return new ToStringBuilder(this)
            .append("collectionSpecimenId", getCollectionSpecimenId())
            .append("collectionId", getCollectionId())
            .append("materialCategory", getMaterialCategory())
            .toString();
    }

    public boolean equals(Object other) {
        if ( (this == other ) ) return true;
        if ( !(other instanceof CollectionStoragePK) ) return false;
        CollectionStoragePK castOther = (CollectionStoragePK) other;
        return new EqualsBuilder()
            .append(this.getCollectionSpecimenId(), castOther.getCollectionSpecimenId())
            .append(this.getCollectionId(), castOther.getCollectionId())
            .append(this.getMaterialCategory(), castOther.getMaterialCategory())
            .isEquals();
    }

    public int hashCode() {
        return new HashCodeBuilder()
            .append(getCollectionSpecimenId())
            .append(getCollectionId())
            .append(getMaterialCategory())
            .toHashCode();
    }

}
