/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * DnDbField.java
 *
 * Created on 28. Juli 2003, 12:04
 */

package net.metadiversity.diversity.navigator.project;

import java.lang.String;

import org.apache.log4j.Logger;

import net.metadiversity.diversity.navigator.ColumnInfo;
/**
 *
 * @author  Dieter Neubacher
 */
public class DnDbField
{
    static Logger logger = Logger.getLogger( DnDbField.class.getName() );
    
    private java.lang.String    projectName;
    private java.lang.String    dbGroupName;
    private java.lang.String    databaseName;
    private java.lang.String    tableName;
    private java.lang.String    fieldName;
    private java.lang.String    description; 
    
    private ColumnInfo          ci;
    
    /** Creates a new instance of DnDbField */
    public DnDbField( java.sql.DatabaseMetaData meta, String databaseName, String tableName, String fieldName ) throws java.sql.SQLException
    {
        this.projectName    = null;
        this.dbGroupName    = null;
        this.databaseName   = databaseName;
        this.tableName      = tableName;
        this.fieldName      = fieldName;
        
        this.description    = null;
        
            java.sql.ResultSet columnResultSet = meta.getColumns( null,  null, tableName, fieldName );
        
            if( columnResultSet.next() ) 
            {
                String name         = columnResultSet.getString(    "COLUMN_NAME" );
                short dataType      = columnResultSet.getShort(     "DATA_TYPE"   );
                String typeName     = columnResultSet.getString(    "TYPE_NAME"   );
                int size            = columnResultSet.getInt(       "COLUMN_SIZE" );
                int decimals        = columnResultSet.getInt(       "DECIMAL_DIGITS");
                int nullable        = columnResultSet.getInt(       "NULLABLE"    );
                String defaultVal   = columnResultSet.getString(    "COLUMN_DEF"  );
                boolean nulls       = ( nullable == java.sql.DatabaseMetaData.columnNullable );

                ci = new ColumnInfo( name, dataType, typeName, size, decimals, nulls, defaultVal );
            }
            else
            {
                ci = null;
            }    
            columnResultSet.close();
    }
    public java.lang.String getName()
    {
        return fieldName;
    }
    public String toString()
    {
        return databaseName + "." + tableName + "." + fieldName;
    }        
}
