/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * DefaultProjectPlugin.java
 *
 * Created on 28. Juli 2003, 10:39
 */

package net.metadiversity.diversity.navigator.project;

import org.apache.log4j.Logger;

/**
 *
 * @author  Dieter Neubacher
 */
public class DnDefaultProjectPlugin
{
    static Logger logger = Logger.getLogger( DnDefaultProjectPlugin.class.getName() );
    
    private java.lang.String    projectName;
    private java.lang.String    description; 
    private java.lang.String    className;
    
    private java.util.LinkedHashMap dnDbGroups;
    
    /** Creates a new instance of DefaultProjectPlugin */
    public DnDefaultProjectPlugin()
    {
        this.projectName = null;
        dnDbGroups = new java.util.LinkedHashMap();
    }
    /**
     * @param projectName
     */    
    public DnDefaultProjectPlugin( java.lang.String projectName )
    {
        this.projectName = projectName;
        dnDbGroups = new java.util.LinkedHashMap();
    }
    
    /** Description for this project.
     * @return Project description.
     */    
    public java.lang.String getDescription()
    {
        return description;
    }
    /** Set the discription for this project.
     * @param description
     */    
    public void setDescription( java.lang.String description )
    {
        this.description = description;
    }
    /** Get the project classname. To load the project use this classname with
     * ClassForName().
     * @return project classname
     */    
    public java.lang.String getClassName()
    {
        return className;
    }
    /** Set the project classname. To load the project use this classname with
     * ClassForName()
     * @param classname Project classname
     */    
    public void setClassName( java.lang.String classname )
    {
        this.className = classname;
    }
    
    /** Add a new DatabaseGroup to this Project
     * @param groupName Database group name
     * @param group Add this DnDBGroup to the Project
     *
     */    
    public void addDnDBGroup( java.lang.String groupName, DnDbGroup group )
    {
        dnDbGroups.put( groupName, group );
        return;
    }
    
    public DnDbGroup getDnDBGroupByName( java.lang.String dnDbGroupName )
    {
        return ( DnDbGroup ) dnDbGroups.get( dnDbGroupName );
    }
}
