/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package net.metadiversity.diversity.navigator.project;

import java.util.*;

import org.apache.log4j.Logger;

public class ProjectInfo 
{
    static Logger logger = Logger.getLogger( ProjectInfo.class.getName() );
    
    private java.lang.String    name;
    private java.lang.String    description;
    private java.util.Hashtable dbgroups;
    private java.lang.String    className;
    
    //--------------------------------------------------------------------------
    public ProjectInfo( String name, String description, String classname ) 
    {
        this.name       = name;
        this.description= description;
        this.className  = classname;
        
        dbgroups = new Hashtable();
    }
    //--------------------------------------------------------------------------
    public ProjectInfo( String name, String description, Hashtable dbgroups ) 
    {
        this.name       = name;
        this.description= description;
        this.dbgroups   = dbgroups;
        this.className  = null;  
    }
    //--------------------------------------------------------------------------
    public String getName()     
    {
        return name; 
    }
    //--------------------------------------------------------------------------
    public String getDescription()   
    { 
        return description; 
    }
    //--------------------------------------------------------------------------
    public Hashtable getDbGroups()   
    { 
        return dbgroups; 
    }
    //--------------------------------------------------------------------------
    public java.lang.String getProjectClassName()   
    { 
        return className; 
    }
}
