/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * DnBoolean.java
 *
 * Created on 8. August 2002, 15:46
 */

package net.metadiversity.diversity.navigator.types;

import org.apache.log4j.Logger;
/**
 *
 * @author  didi
 */
public class DnBoolean
{
    static Logger logger = Logger.getLogger( DnBoolean.class.getName() );
    
    public final static int valFalse = -1;
    public final static int valTrue  = 1;
    public final static int valNull  = 0;
    
    public final boolean debugFlag = false;
    private int value;
    
    /** Creates new form DnBoolean */
    public DnBoolean() 
    {
        value = 0;
    }

    public DnBoolean( int val ) 
    {
        setValue( val );
    }
    
    public DnBoolean( String str ) 
    {
        setValue( str );
    }

    public int getValue()
    {
        if( debugFlag ) logger.debug( "getValue() : " + value ); 
	return value;
    }
    
    public void setValue( int val )
    {
        if( debugFlag ) logger.debug( "setValue() : " + val ); 
	if( val == 0 ) value = 0;
	else
	    if( val > 0 ) value = 1;
	    else
		if( val < 0 ) value = -1;
        
        if( debugFlag ) logger.debug( "setValue( int ) : " + value ); 
    }
    
    public void setValue( String val )
    {
        if( debugFlag ) logger.debug( "setValue( String ) : " + val ); 
	if( val == null || val.equals( "null" ) ) 
        {
            value = 0;
        }
	else
        {    
	    if( val.equals( "t" ) ) 
                value = 1;
	    else
		if( val.equals( "f" ) ) 
                    value = -1; 
		
		// ??? MS-SQL ???
		
	    else if( val.equals( "1" ) ) 
            	value = 1;
	    else if( val.equals( "0" ) ) 
                value = -1; 

		
        }
        if( debugFlag ) logger.debug( "setValue() : " + value ); 
    }
    public String toString()
    {
        if( debugFlag ) logger.debug( "toString() : " + value ); 
	switch( value )
	{
	    case valFalse : return "false";
	    case valTrue :  return "true";
	    case valNull :  
            default:        return "null";
	}
    }    
}
