/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * LogCellRenderer.java
 *
 * Created on 5. Mai 2003, 15:27
 */

package net.metadiversity.diversity.navigator.util;

import javax.swing.*;

import org.apache.log4j.*;
import org.apache.log4j.Logger;

/**
 *
 * @author  didi
 */
public class LogCellRenderer extends javax.swing.JLabel implements ListCellRenderer
{    
    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 4049914974342035767L;
    
    static Logger logger = Logger.getLogger( LogCellRenderer.class.getName() );
    /** Creates a new instance of LogCellRenderer */
    public LogCellRenderer() 
    {
        if( logger.isDebugEnabled() )
        {
            logger.debug( "LogCellRenderer() Create Renderer");
        }
    }
    
    public java.awt.Component getListCellRendererComponent( javax.swing.JList jList, 
                                                            Object obj, 
                                                            int index, 
                                                            boolean isSelected, 
                                                            boolean cellHasFocus )
    {
        if( logger.isDebugEnabled() )
        {
            logger.debug( "getListCellRendererComponent()" );
        }
        // System.out.println( "Get List Cell Renderer Component : index " + index );
        // ??? setFont( new java.awt.Font( "Dialog", 0, 12 ) );
        Level level = ((LogEvent)obj).level;
        if( level == Level.FATAL )
        {    
            setForeground( new java.awt.Color( 128, 0, 128 ) );
        }
        else if( level == Level.ERROR )
        {    
            setForeground( new java.awt.Color( 255, 0, 0 ) );
        }
        else if( level == Level.WARN )
        {
            setForeground( new java.awt.Color( 0, 255, 0 ) );
        }
        else if( level == Level.INFO )
        {    
            setForeground( new java.awt.Color( 0, 0, 255 ) );
        }    
        else if( level == Level.DEBUG )
        {    
             setForeground( new java.awt.Color( 0, 0, 0 ) );
        }                   
        String str = ((LogEvent)obj).text;
        int pos;
        if( str != null && str.startsWith( "FATAL" ) )
        {
            pos = str.indexOf( "]:" );
            if( pos > 0 )
            {    
                str = str.substring( pos + 2  );
            }    
            // format message when multiple lines used
            boolean htmlFlag = false;
            while( (pos = str.indexOf( '\n' )) > 0 )
            {
                htmlFlag = true;
                str = str.substring( 0, pos ) + "<P>" + str.substring( ++pos ); 
            }
            if( htmlFlag )
            {
                str = "<HTML><BODY>" + str + "</BODY></HTML>";
            }
        }
        setText( str );
        return this;
    }
}
