/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * PreInstall.java
 *
 * Created on 5. April 2003, 19:38
 */

package net.metadiversity.diversity.navigator.util;

import java.lang.System;
import java.io.*;

import org.apache.log4j.Logger;

/**
 *
 * @author  didi
 */
// Don't use logger for output messages, because the logging is not working at this time.
public class PreInstall
{    
    static Logger logger = Logger.getLogger( PreInstall.class.getName() );
    /** Creates a new instance of PreInstall */
    public PreInstall()
    {
        try
        {
            // create configuration directory           
            String home = System.getProperty( "user.home" );        
            File configDir = new File( home + File.separator + ".diversity_navigator" );
        
            if( configDir.exists() )
            {
                // config dir allready exist
                return;
            }
            else
            {
                // ceate config dir
                configDir.mkdir();
            }
            // current directory        
            String from = System.getProperty( "user.dir" );
            String to   = home + File.separator + ".diversity_navigator";   
            // copy configuration file             
            String outFile = to   + File.separator + "diversity_navigator.log.xml";            
            String inFile  = from + File.separator + "configtemplate" + File.separator + "diversity_navigator.log.xml";            
            filecopy( inFile, outFile );            
            outFile = to   + File.separator + "diversity_navigator.projects.xml";            
            inFile  = from + File.separator + "configtemplate" + File.separator + "diversity_navigator.projects.xml";            
            filecopy( inFile, outFile );            
            outFile = to   + File.separator + "diversity_navigator.projects.dtd";            
            inFile  = from + File.separator + "configtemplate" + File.separator + "diversity_navigator.projects.dtd";            
            filecopy( inFile, outFile );
            outFile = to   + File.separator + "diversity_navigator.services.xml";            
            inFile  = from + File.separator + "configtemplate" + File.separator +"diversity_navigator.services.xml";
            filecopy( inFile, outFile );
            outFile = to   + File.separator + "diversity_navigator.services.dtd";            
            inFile  = from + File.separator + "configtemplate" + File.separator +"diversity_navigator.services.dtd";
            filecopy( inFile, outFile );
            // Transekt data for ubt-collection
            outFile = to   + File.separator + "diversity_navigator.collection.observatories.xml";            
            inFile  = from + File.separator + "configtemplate" + File.separator +"diversity_navigator.collection.observatories.xml";
            filecopy( inFile, outFile );
            // NaviKey.props
            outFile = to   + File.separator + "NaviKey.props";            
            inFile  = from + File.separator + "configtemplate" + File.separator +"NaviKey.props";
            filecopy( inFile, outFile );
        }
        catch( java.io.IOException ex )
        {
            ex.printStackTrace(); 
        }
    }
    //
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public void filecopy( String from, String to ) throws java.io.IOException
    {            
        File toFile   = new File( to );
        File fromFile = new File( from );
        
        FileInputStream  fis = null;
        FileOutputStream fos = null;
        try
        {
            fis = new FileInputStream( fromFile );
            fos = new FileOutputStream( toFile );
            // Message to console
            System.out.println( "copy " + from + " to " + to );
            int ch = 0;            
            while( ch >= 0 )
            {   
                ch = fis.read();
                if( ch != -1 )
                {    
                    fos.write( ch );
                }    
            }   
            return;
        }
        finally
        {
            fis.close();
            fos.close();        
        }
    }       
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public static void main( String args[] ) 
    {
        new PreInstall();
    }
}
