/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * ChecklistsGrassGissVisualisierungService.java
 *
 * Created on 30. Juli 2003, 19:06
 */

// ??? REMOVE THIS LINE 
package net.metadiversity.diversity.navigator.webservice;

import org.apache.log4j.Logger;
import org.apache.log4j.Level;

/**
 *
 * @author  Dieter Neubacher
 */
public class ChecklistsGrassGisVisualisationService
{
    static Logger logger = Logger.getLogger( ChecklistsGrassGisVisualisationService.class.getName() );
    
    static int    mapNumber     = 0;
    static int    maxMapCount   = 10;
    static String userName;
    static String homeDir;
    static String scriptName        = "/grass/script_world.sh";
    static String mapFileNamePart   = "-grass-map-";
    static String mapFileExtension  = ".gif";
    /** Creates a new instance of ChecklistsGrassGissVisualisierungService */
    public ChecklistsGrassGisVisualisationService()
    {
        userName    = System.getProperty( "user.name" );
        homeDir     = System.getProperty( "user.home" );       
    }
    synchronized int getMapNumber()
    {
        mapNumber++;
        if( mapNumber >= maxMapCount )
        {
            mapNumber = 0;
        }    
        return mapNumber;
    }
    public String visualisation( String locations ) 
    {
        String mapFileName = userName + mapFileNamePart + getMapNumber();
        if( logger.isDebugEnabled() )
        {
            logger.debug( "MapFile: " + mapFileName );
        }
        try
        {
            int execReturn = 0;
            Runtime rt = Runtime.getRuntime();
            if( logger.isDebugEnabled() ) logger.debug( "start" );
            String exec = homeDir + scriptName + " " +  mapFileName + " " + locations;
            if( logger.isDebugEnabled() ) logger.debug( "execute: " + exec );
	    Process p = rt.exec( exec );
            p.waitFor();
            if( logger.isDebugEnabled() ) logger.debug( "finish" );
            execReturn = p.exitValue();
            
            return mapFileName;
        }
        catch( java.io.IOException ex )
        {
            return "Can't execute GRASS-GIS";
        }
        
        catch( java.lang.InterruptedException ex )
        {
            return ex.getLocalizedMessage();
        }
    }
    //--------------------------------------------------------------------------
    //
    //--------------------------------------------------------------------------
    public static void main( String [] args )
    {        
       org.apache.log4j.BasicConfigurator.configure();
       logger.setLevel( Level.DEBUG );
        // test
        ChecklistsGrassGisVisualisationService webService = new ChecklistsGrassGisVisualisationService();
        for( int i = 0; i < 2 * maxMapCount; i++ )
        {    
            System.out.println( "Return: " + webService.visualisation( "1000111" ) );
        }    
    }
}
